/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid;

import java.awt.Component;
import java.util.Vector;
import java.util.Enumeration;
import gvid.ui.FindSettings;

public abstract class Globals {
	public final static String VISIBLETAB = "";
	public final static String INVISIBLETAB = " ";
	private static String m_tabDisplay = INVISIBLETAB;
	private static Vector m_tabListeners = new Vector();
	
	public static String getTabDisplay() {
		return m_tabDisplay;
	}
	
	public static void setTabDisplay(boolean display) {
		if( display && m_tabDisplay != VISIBLETAB ) {
			m_tabDisplay = VISIBLETAB;
			repaintTabListeners();
		} else if( !display && m_tabDisplay != INVISIBLETAB ) {
			m_tabDisplay = INVISIBLETAB;
			repaintTabListeners();
		}
	}
	
	public static void addTabDisplayListener( Component c ) {
		m_tabListeners.addElement(c);
	}
	
	public static void removeTabDisplayListener( Component c ) {
		m_tabListeners.removeElement(c);
	}
	
	private static void repaintTabListeners() {
		Enumeration enum = m_tabListeners.elements();
		while( enum.hasMoreElements() ) {
			Component c = (Component)enum.nextElement();
			c.repaint();
		}
	}
	
	public static FindSettings m_findSettings = new FindSettings();
}