/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.command;

public interface CommandBase {
	public static final int FILEGROUP		= 0;
	public static final int EDITGROUP		= 1;
	public static final int VIEWGROUP		= 2;
	public static final int PROJECTGROUP	= 3;
	public static final int TOOLGROUP		= 4;
	public static final int WINDOWGROUP 	= 5;
	public static final int HELPGROUP		= 6;
	/* Also: 
		CodeGenBar, Insert, Project, Build, Debug, Layout, Query, Diagram, 
	*/
	public void executeCommand( int cmd );
	public int getCommandGroup();
	public boolean isAvailable( int cmd );
}