/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.command;

import java.awt.event.KeyEvent;

public class CommandKey {
	int m_keyCode = -1;
	int m_modifiers = 0;
	
	public CommandKey( int keycode, int modifiers ) {
		m_keyCode = keycode;
		m_modifiers = modifiers;
	}
	
	public boolean equals( Object obj ) {
		boolean rc = false;
		if( obj instanceof CommandKey ) {
			CommandKey ck = (CommandKey)obj;
			rc = (m_keyCode==ck.m_keyCode)&&(m_modifiers==ck.m_modifiers);
		}
		return rc;
	}
	
	public int hashCode() {
		return m_keyCode*16 + m_modifiers;
	}
	
	public String toString() {
		return "["+KeyEvent.getKeyText(m_keyCode)+","+KeyEvent.getKeyModifiersText(m_modifiers)+"]";
	}	
}