/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.command;

public interface FileCommands extends CommandBase {
	public static final int APPLICATIONEXIT = 0;
	public static final int FILECLOSE = 1;
	public static final int FILEGOTO = 2;
	public static final int FILEOPEN = 3;
	public static final int FILEPRINT = 4;
	public static final int FILEPRINTPAGESETUP = 5;
	public static final int FILESAVE = 6;
	public static final int FILESAVEALL = 7;
	public static final int FILESAVEALLEXIT = 8;
	public static final int FILESAVEAS = 9;
	public static final int NEWITEM = 10;
	public static final int NEWTEXT = 11;
	public static final int WORKSPACECLOSE = 12;
	public static final int WORKSPACEOPEN = 13;
	public static final int WORKSPACESAVE = 14;
	public static final int WINDOWCLOSEALL = 15;
	public static final int WINDOWNEXT = 16;
	public static final int WINDOWPREV = 17;
	public static final int WINDOWCASCADE = 18;
	public static final int WINDOWTILEHORIZONTAL = 19;
	public static final int WINDOWTILEVERTICAL = 20;
	public static final int WINDOWTILE = 21;
	public static final int WINDOWLIST = 22;
	public static final int PROJECTNEW = 23;
	public static final int PROJECTOPEN = 24;
	public static final int PROJECTSAVE = 25;
	public static final int PROJECTCLOSE = 26;	

	public void applicationExit();		// quits the application; prompts to save documents
	public void fileClose();			// Closes the document
	public void fileGoTo();				// Opens a file based on selected text
	public void fileOpen(); 			// Opens an existing document
	public void filePrint();			// Prints all or part of a document
	public void filePrintPageSetup();	// Changes the page layout settings
	public void fileSave();				// Save the document
	public void fileSaveAll();			// Saves all open files
	public void fileSaveAllExit();		// Saves all open files and exits the application
	public void fileSaveAs();			// Saves the document with a new name
	public void newItem();				// Creates a new document, project or workspace
	public void newText();				// Creates a new file
	public void workspaceClose();		// Closes the workspace
	public void workspaceOpen();		// Opens an existing workspace
	public void workspaceSave();		// Saves the workspace
	public void windowCloseAll();		// Closes all open windows
	public void windowNext();			// Activates the next window
	public void windowPrev();			// Activates the previous window
	public void windowCascade();		// Arranges windows as overlapping tiles
	public void windowTileHorizontal();	// Arranges the windows as horizonal, non-overlappaing tiles
	public void windowTileVertical();	// Arranges the windows as vertical, non-overlapping tiles
	public void windowTile();			// Arranges the windows in a grid as non-overlapping tiles
	public void windowList();			// Manges the currently open windows
	public void windowMaximize();		// Maximizes or restores the current window
	public void projectNew();			// Creates and names a new project
	public void projectOpen();			// Creates and names a new project
	public void projectSave();			// Saves the current project
	public void projectClose();			// Closes the current project
}
