/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.command;

public interface ProjectCommands extends CommandBase {
	public static final int PROJECTSETTINGS = 0;
	public static final int ADDFILES = 1;
	public static final int COMPILEFILE = 2;
	public static final int BUILD = 3;
	public static final int CLEAN = 4;
	public static final int REBUILDALL = 5;
	public static final int EXECUTE = 6;
	public static final int DEBUG = 7;
	public static final int ATTACHDEBUG = 8;
	
	public void projectSettings();		// Edit the project settings	
	public void addFiles();				// Adds files to the project
	public void compileFile();			// Compiles the current file
	public void build();				// Builds the current project
	public void rebuildAll();			// Rebuilds all of the files in the current project
	public void clean();				// Removes the build files
	public void execute();				// Starts the program
	public void debug();				// Starts or continues debugging the program
	public void attachDebug();			// Attaches the debugger to a running application
}
