/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.command;

public interface WindowCommands {
	public static final int WINDOWCLOSEALL = 0;
	public static final int WINDOWNEXT = 2;
	public static final int WINDOWPREV = 3;
	public static final int WINDOWCASCADE = 4;
	public static final int WINDOWTILEHORIZONTAL = 5;
	public static final int WINDOWTILEVERTICAL = 6;
	public static final int WINDOWTILE = 7;
	public static final int WINDOWLIST = 8;    
	public void windowCloseAll();
	public void windowNext();
	public void windowPrev();
	public void windowCascade();
	public void windowTileHorizontally();
	public void windowTileVertically();	
	public void windowTile();	
	public void windowList();
	
	public void windowClose();
	public void windowCycle();
	public void windowDeleteColRight();
	public void windowDeleteColLeft();
	public void windowDeleteRowDown();
	public void windowDeleteRowUp();
	public void windowDockingView();
	public void windowHide();
	public void windowKillPane();
	public void windowMaximize();
	public void windowNewWindow();
	public void windowNextMDI();
	public void windowNextPane();
	public void windowPrevious();
	public void windowPreviousMDI();
	public void windowPrevPane();
	public void windowSinglePane();
	public void windowSplit();
	public void windowSplitHorizontal();
	public void windowSplitVertical();
	public void windowSwitchPaneDown();
	public void windowSwitchPaneLeft();
	public void windowSwitchPaneRight();
	public void windowSwitchPaneUp();
}