/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.project;

import gvid.util.*;
import gvid.*;

import java.util.*;
import java.awt.event.*;

public class ProjectListListener 
	implements	gvid.util.ListIteratorListener, 
				gvid.util.ListListener, 
				java.awt.event.ActionListener {
	private Vector m_listCopy = new Vector();
	private ProjectModel m_project = null;
	private List m_list = null;
		
	public ProjectListListener( ProjectModel project, List list ) {
		m_project = project;
		m_list = list;
		m_timer = new javax.swing.Timer(100, this);
		m_timer.setInitialDelay(100);
		m_timer.setRepeats(false);
	}
				
	public void clear() {
		m_listCopy.clear();
		m_listCopy.addAll( m_list );
	}
		
	public boolean isDirty() {
		boolean rc = false;
		rc = rc || !m_listCopy.containsAll(m_list);
		rc = rc || !m_list.containsAll(m_listCopy);
		return rc;
	}
		
	public void listChanged( NotifyingList list ) {
		m_timer.restart();
	}
		
	javax.swing.Timer m_timer = null;
	public void listIteratorChanged( NotifyingListIterator list ) {
		m_timer.restart();
	}		
		
	public void actionPerformed(java.awt.event.ActionEvent e) {
		m_timer.stop();
		m_project.updateDirty();
		m_project.notifyFilesChanged();
	}
	//{{DECLARE_CONTROLS
	//}}
}