/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.ui;

import javax.swing.*;
import java.beans.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;
import gvid.command.EditCommands;
import gvid.Globals;
import java.util.*;
import gvid.undo.*;
import gvid.ui.editor.SourceCodeEditor;

public class FindPanel 
	extends 	javax.swing.JPanel 
	implements	ActionListener
				
	{
	MainFrame m_mainFrame = null;
	SourceCodeEditor m_editor = null;
		
	public FindPanel(MainFrame mainFrame) {
		m_mainFrame = mainFrame;
		
		setLayout(new GridBagLayout());
		setSize(651,332);
		m_findLabelWrapper.setLayout(new FlowLayout(FlowLayout.LEFT,5,5));
		add(m_findLabelWrapper, new java.awt.GridBagConstraints(0,0,1,1,0.0,0.0,java.awt.GridBagConstraints.WEST,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		m_findLabel.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
		m_findLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		m_findLabel.setText("Find what:");
		m_findLabelWrapper.add(m_findLabel);
		m_findLabel.setForeground(java.awt.Color.black);
//		m_findLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		m_findFieldWrapper.setLayout(new BoxLayout(m_findFieldWrapper,BoxLayout.X_AXIS));
		add(m_findFieldWrapper, new java.awt.GridBagConstraints(1,0,5,1,0.0,0.0,java.awt.GridBagConstraints.WEST,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		m_findField.setEditable(true);
		m_findFieldWrapper.add(m_findField);
//		m_findField.setFont(new Font("Dialog", Font.PLAIN, 12));
		m_buttonPanel.setLayout(new GridLayout(2,1,0,10));
		add(m_buttonPanel, new java.awt.GridBagConstraints(7,0,1,3,0.0,0.0,java.awt.GridBagConstraints.NORTHEAST,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,10,0,0),0,0));
		m_findButton.setText("Find Next");
		m_findButton.setActionCommand("FIND");
		m_findButton.setDefaultCapable(true);
		m_buttonPanel.add(m_findButton);
//		m_findButton.setFont(new Font("Dialog", Font.PLAIN, 12));
		m_cancelButton.setActionCommand("CANCEL");
		m_cancelButton.setText("Cancel");
		m_buttonPanel.add(m_cancelButton);
//		m_cancelButton.setFont(new Font("Dialog", Font.PLAIN, 12));
		m_optionPanel.setLayout(new BoxLayout(m_optionPanel,BoxLayout.Y_AXIS));
		add(m_optionPanel,new java.awt.GridBagConstraints(0,2,2,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		m_wholeWordOption.setText("Match whole word only");
		m_optionPanel.add(m_wholeWordOption);
//		m_wholeWordOption.setFont(new Font("Dialog", Font.PLAIN, 12));
		m_matchCaseOption.setText("Match case");
		m_optionPanel.add(m_matchCaseOption);
//		m_matchCaseOption.setFont(new Font("Dialog", Font.PLAIN, 12));
		m_wrapOption.setText("Wrap around");
		m_optionPanel.add(m_wrapOption);
//		m_wrapOption.setFont(new Font("Dialog", Font.PLAIN, 12));
		m_directionPanel.setBorder(titledBorder1);
		m_directionPanel.setLayout(new BoxLayout(m_directionPanel,BoxLayout.Y_AXIS));
		add(m_directionPanel,new java.awt.GridBagConstraints(3,2,2,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		m_upRadio.setText("Up");
		m_directionPanel.add(m_upRadio);
//		m_upRadio.setFont(new Font("Dialog", Font.PLAIN, 12));
		m_downRadio.setText("Down");
		m_directionPanel.add(m_downRadio);
//		m_downRadio.setFont(new Font("Dialog", Font.PLAIN, 12));
		m_filler1.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		add(m_filler1, new java.awt.GridBagConstraints(0,1,4,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.BOTH,new Insets(0,0,0,0),0,0));
		m_filler2.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		add(m_filler2, new java.awt.GridBagConstraints(6,0,1,5,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.BOTH,new Insets(0,0,0,0),0,0));
		m_filler3.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		add(m_filler3, new java.awt.GridBagConstraints(2,2,1,2,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.BOTH,new Insets(0,0,0,0),0,0));
		titledBorder1.setTitleFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12));
		titledBorder1.setTitle("Direction");
		titledBorder1.setTitleColor(java.awt.Color.black);
		titledBorder1.setBorder(etchedBorder1);
		
		m_cancelButton.addActionListener(this);
		m_findButton.addActionListener(this);
		m_findField.getEditor().addActionListener(this);
		
		m_directionGroup.add(m_upRadio);
		m_directionGroup.add(m_downRadio);
	}
	
	public void init() {
		m_findField.requestFocus();
		getRootPane().setDefaultButton(m_findButton);
		loadSettings();
	}
	
	public void setEditor( SourceCodeEditor editor ) {
		m_editor = editor;
	}
	
	private void loadSettings() {
		m_wholeWordOption.setSelected(Globals.m_findSettings.m_bWholeWord);
		m_matchCaseOption.setSelected(Globals.m_findSettings.m_bMatchCase);
		m_wrapOption.setSelected(Globals.m_findSettings.m_bWrap);
		switch( Globals.m_findSettings.m_direction ) {
			case FindSettings.DOWN: m_downRadio.setSelected(true); break;
			case FindSettings.UP: m_upRadio.setSelected(true); break;			
		}
		m_findField.removeAllItems();
		Iterator iter = Globals.m_findSettings.m_findList.iterator();
		while( iter.hasNext() ) {
			String str = (String)iter.next();
			m_findField.addItem(str);
		}
		if( m_editor.getSelection() != null ) {
			m_findField.getEditor().setItem(m_editor.getSelection().getSelectedText());
		} else {
			m_findField.getEditor().setItem(Globals.m_findSettings.m_findString);
		}
		m_findField.getEditor().selectAll();
	}
	
	private void saveSettings() {
		Globals.m_findSettings.m_findString = (String)m_findField.getEditor().getItem();
		Globals.m_findSettings.addFindString(Globals.m_findSettings.m_findString);
		Globals.m_findSettings.m_bMatchCase = m_matchCaseOption.isSelected();
		Globals.m_findSettings.m_bWholeWord = m_wholeWordOption.isSelected();
		Globals.m_findSettings.m_bWrap = m_wrapOption.isSelected();
		if( m_downRadio.isSelected() ) {
			Globals.m_findSettings.m_direction = FindSettings.DOWN;
		} else {
			Globals.m_findSettings.m_direction = FindSettings.UP;
		}
	}

	public void find() {
		saveSettings();
		m_editor.getEditCommands().clearSelection();
		if( Globals.m_findSettings.m_direction == FindSettings.UP ) {
			m_editor.getEditCommands().findPrev();
		} else {
			m_editor.getEditCommands().findNext();
		}
		if( m_editor.getSelection() != null ) {
			m_findDialog.setVisible(false);
		} else {
			JOptionPane.showMessageDialog(m_findDialog, "Cannot find the string'"+Globals.m_findSettings.m_findString+"'.");
		}
	}
	
	public void cancel() {
		m_findDialog.setVisible(false);
	}

	javax.swing.JPanel m_findLabelWrapper = new javax.swing.JPanel();
	javax.swing.JLabel m_findLabel = new javax.swing.JLabel();
	javax.swing.JPanel m_findFieldWrapper = new javax.swing.JPanel();
	javax.swing.JComboBox m_findField = new javax.swing.JComboBox();
	javax.swing.JPanel m_buttonPanel = new javax.swing.JPanel();
	javax.swing.JButton m_findButton = new javax.swing.JButton();
	javax.swing.JButton m_cancelButton = new javax.swing.JButton();
	javax.swing.JPanel m_optionPanel = new javax.swing.JPanel();
	javax.swing.JCheckBox m_wholeWordOption = new javax.swing.JCheckBox();
	javax.swing.JCheckBox m_matchCaseOption = new javax.swing.JCheckBox();
	javax.swing.JCheckBox m_wrapOption = new javax.swing.JCheckBox();
	javax.swing.JPanel m_directionPanel = new javax.swing.JPanel();
	javax.swing.JRadioButton m_upRadio = new javax.swing.JRadioButton();
	javax.swing.JRadioButton m_downRadio = new javax.swing.JRadioButton();
	javax.swing.JPanel m_filler1 = new javax.swing.JPanel();
	javax.swing.JPanel m_filler2 = new javax.swing.JPanel();
	javax.swing.JPanel m_filler3 = new javax.swing.JPanel();
	javax.swing.border.TitledBorder titledBorder1 = new javax.swing.border.TitledBorder("Direction");
	javax.swing.border.EtchedBorder etchedBorder1 = new javax.swing.border.EtchedBorder();
	javax.swing.ButtonGroup m_directionGroup = new ButtonGroup();

///////////////////////////////////////////////////////////////////////////////
//	ActionListener
	public void actionPerformed(ActionEvent e) {
		if( e.getActionCommand().equals("FIND") ) {
			find();
		} else if( e.getActionCommand().equals("CANCEL") ) {
			cancel();
		} else if( e.getSource() == m_findField.getEditor().getEditorComponent() ) {
			find();
		}
	}
//	ActionListener
///////////////////////////////////////////////////////////////////////////////

	static JDialog m_findDialog = null;
	static FindPanel m_findPanel = null;
	public static void showDialog( MainFrame mainFrame, SourceCodeEditor editor) {
		if( m_findDialog == null ) {
			m_findDialog = new JDialog(mainFrame, "Find", true);
			m_findPanel = new FindPanel(mainFrame);
			m_findDialog.setSize(375, 175);
			m_findDialog.setResizable(false);
			
			m_findDialog.getContentPane().setLayout(new BorderLayout());
			m_findDialog.getContentPane().add(m_findPanel, BorderLayout.CENTER);
			
			gvid.Util.recurseAddKeyListener(m_findDialog, new KeyAdapter() {
				public void keyPressed( KeyEvent evt ) {
					if( evt.getKeyCode() == KeyEvent.VK_ESCAPE ) {
						m_findPanel.cancel();
					}
				}
			});
		}
//		m_findPanel.setWindows(windows);

		Point pos = mainFrame.getLocation();
		Dimension size1 = mainFrame.getSize();
		Dimension size2 = m_findDialog.getSize();
		m_findDialog.setLocation( pos.x+size1.width/2-size2.width/2, pos.y+size1.height/2-size2.height/2 );
		m_findPanel.setEditor(editor);
		
		m_findDialog.addComponentListener(new ComponentAdapter() {
    		public void componentShown(ComponentEvent e) {
    			m_findPanel.init();
    		}
		});
		m_findDialog.setVisible(true);
	}
}