/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.ui.border;

import javax.swing.border.*;

import java.awt.*;
public class SimpleBevelBorder 
	implements javax.swing.border.Border {
	Insets m_insets = new Insets(2,2,2,2);
	    
	public void paintBorder(Component c, Graphics g, int x, int y, int width, int height) {
	    g.setColor(Color.gray);
	    g.drawLine(x,y,x+width,y);
	    g.drawLine(x,y,x,y+height-1);
	        
	    g.setColor(Color.black);
	    g.drawLine(x+1,y+1,x+width-2,y+1);
	    g.drawLine(x+1,y+1,x+1,y+height-1);
	        
	    g.setColor(Color.white);
	    g.drawLine(x+width-1, y, x+width-1, y+height);
	    g.drawLine(x, y+height-1, x+width, y+height-1);
	        
	    g.setColor(Color.lightGray);
	    g.drawLine(x+width-2, y+1, x+width-2, y+height-2);
	    g.drawLine(x+1, y+height-2, x+width-2, y+height-2);
	}
	    
    public Insets getBorderInsets(Component c) {
        return (Insets)m_insets.clone();
    }

    public boolean isBorderOpaque() {
        return false;
    }	    
}