/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.ui.splitscrollpane;

import javax.swing.*;
import java.awt.Rectangle;
import java.awt.Component;

public interface SplitScrollView {
    public SplitScrollView createCopy();
    public void copySettingsFrom( SplitScrollView view );
    public BoundedRangeModel getVerticalScrollModel();
    public BoundedRangeModel getHorizontalScrollModel();
    public void shareVerticalScrollModel( SplitScrollView view );
    public void shareHorizontalScrollModel( SplitScrollView view );
    public int horizontalUnits( int width );
    public int verticalUnits( int height );
    public void setModel( SplitScrollModel model );
    public SplitScrollModel getModel();
    public void clearModel();
    
    public Rectangle getViewBounds();
    
    public boolean isActive();
    public void setActive(boolean active); 
    
    // methods to allow data models to redraw the view
    // make more generic in the future
    public void repaint();
    public void invalidate();
    
    public Component asComponent();
    public void doLayout();
}