/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.util;

import javax.swing.*;
import java.util.*;

public class StringListModel extends javax.swing.AbstractListModel {
	Vector m_listItems = new Vector();
	
    public Object getElementAt(int index) {
        Object rc = null;
        rc = m_listItems.get(index);
        return rc;
    }

    public int getSize() {
        return m_listItems.size();
    }
    
    public void addItem() {
    	m_listItems.add("");
    	fireIntervalAdded(this, getSize(), getSize());
    }
    
    public void removeItem( int index ) {
    	m_listItems.remove(index);
    	fireIntervalRemoved(this, index, index);
    }
    
    public void moveItemUp( int index ) {
    	if( index > 0 ) {
    		m_listItems.add( index-1, m_listItems.remove(index) );
    		fireContentsChanged(this, index-1, index);
    	}
    }
    
    public void moveItemDown( int index ) {
    	if( index < getSize()-1 ) {
    		m_listItems.add( index+1, m_listItems.remove(index) );
    		fireContentsChanged(this, index, index+1);    		
    	}
    }
}